@prefix flint: <http://ontology.tno.nl/normengineering/flint#> .
@prefix int: <http://ontology.tno.nl/examples/tictactoe/interpretation#> .
@prefix imp: <http://ontology.tno.nl/examples/tictactoe/implementation#> .
@prefix rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#> .
@prefix rdfs: <http://www.w3.org/2000/01/rdf-schema#> .
@prefix sh:   <http://www.w3.org/ns/shacl#> .
@prefix prov: <http://www.w3.org/ns/prov#> .
@prefix ttt: <http://ontology.tno.nl/examples/tictactoe/domain-ontology#> .

# Implementations of preconditions

imp:actorHasTurnPre a sh:NodeShape ;
  rdfs:label "actor has the turn" ;
  sh:property [
    sh:path (flint:hasObject [ sh:inversePath ttt:hasSquare ] ttt:playerTurn) ;
    sh:equals flint:hasActor ;
  ]
.

imp:objectIsEmpty a sh:NodeShape ;
  rdfs:label "object (square) is empty" ;
  sh:property [
    sh:path (flint:hasObject ttt:hasContent) ;
    sh:maxCount 0 ;
  ]
.

# A complex precondition could be defined as follows:
imp:objectIsEmptyOrContainsX a sh:NodeShape  ;
  rdfs:label "object (square) is empty or contains X" ;
  sh:or (
    [
      sh:path (flint:hasObject ttt:hasContent) ;
      sh:maxCount 0 ;
    ]
    [
      sh:path (flint:hasObject ttt:hasContent) ;
      sh:hasValue "X" ;
    ]
  )
.

# Implementations of postconditions

imp:recipientHasTurn a sh:TripleRule ; # Describes a triple that will be created
  rdfs:label "recipient has the turn" ;
  sh:subject [sh:path (flint:hasObject [ sh:inversePath ttt:hasSquare ])] ; # Path to the game
  sh:predicate ttt:playerTurn ;
  sh:object [sh:path flint:hasRecipient] ;
.

imp:actorSymbolInObject a sh:TripleRule ; # Describes a triple that will be created
  rdfs:label "the object (a square) contains the symbol of the actor (X or O)" ;
  sh:subject [sh:path flint:hasObject] ;
  sh:predicate ttt:hasContent ;
  sh:object [sh:path (flint:hasActor ttt:hasSymbol)] ;
.

imp:actorHasTurnPost a sh:TripleRule ; # Describes a triple that will be terminated
  rdfs:label "actor has the turn" ;
  sh:subject [sh:path (flint:hasObject [ sh:inversePath ttt:hasSquare ])] ; # Path to the game
  sh:predicate ttt:playerTurn ;
  sh:object [sh:path flint:hasActor];
.
